Index: libcfa/src/iostream.cfa
===================================================================
--- libcfa/src/iostream.cfa	(revision e3fea427569271c0c15fd2ca6d3296f213856ead)
+++ libcfa/src/iostream.cfa	(revision 13d2dacf5c90156542e275ae9391bbaba5f9e387)
@@ -10,6 +10,6 @@
 // Created On       : Wed May 27 17:56:53 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Tue Feb  4 10:07:17 2020
-// Update Count     : 822
+// Last Modified On : Fri Feb  7 18:48:38 2020
+// Update Count     : 825
 //
 
@@ -35,5 +35,5 @@
 forall( dtype ostype | ostream( ostype ) ) {
 	ostype & ?|?( ostype & os, zero_t ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%d", 0n );
 		return os;
@@ -44,5 +44,5 @@
 
 	ostype & ?|?( ostype & os, one_t ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%d", 1n );
 		return os;
@@ -53,5 +53,5 @@
 
 	ostype & ?|?( ostype & os, bool b ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%s", b ? "true" : "false" );
 		return os;
@@ -63,5 +63,5 @@
 	ostype & ?|?( ostype & os, char c ) {
 		fmt( os, "%c", c );
-		if ( c == '\n' ) setNL( os, true );
+		if ( c == '\n' ) $setNL( os, true );
 		return sepOff( os );
 	} // ?|?
@@ -71,5 +71,5 @@
 
 	ostype & ?|?( ostype & os, signed char sc ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%hhd", sc );
 		return os;
@@ -80,5 +80,5 @@
 
 	ostype & ?|?( ostype & os, unsigned char usc ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%hhu", usc );
 		return os;
@@ -89,5 +89,5 @@
 
 	ostype & ?|?( ostype & os, short int si ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%hd", si );
 		return os;
@@ -98,5 +98,5 @@
 
 	ostype & ?|?( ostype & os, unsigned short int usi ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%hu", usi );
 		return os;
@@ -107,5 +107,5 @@
 
 	ostype & ?|?( ostype & os, int i ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%d", i );
 		return os;
@@ -116,5 +116,5 @@
 
 	ostype & ?|?( ostype & os, unsigned int ui ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%u", ui );
 		return os;
@@ -125,5 +125,5 @@
 
 	ostype & ?|?( ostype & os, long int li ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%ld", li );
 		return os;
@@ -134,5 +134,5 @@
 
 	ostype & ?|?( ostype & os, unsigned long int uli ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%lu", uli );
 		return os;
@@ -143,5 +143,5 @@
 
 	ostype & ?|?( ostype & os, long long int lli ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%lld", lli );
 		return os;
@@ -152,5 +152,5 @@
 
 	ostype & ?|?( ostype & os, unsigned long long int ulli ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%llu", ulli );
 		return os;
@@ -175,5 +175,5 @@
 
 	ostype & ?|?( ostype & os, float f ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		PrintWithDP( os, "%g", f );
 		return os;
@@ -184,5 +184,5 @@
 
 	ostype & ?|?( ostype & os, double d ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		PrintWithDP( os, "%.*lg", d, DBL_DIG );
 		return os;
@@ -193,5 +193,5 @@
 
 	ostype & ?|?( ostype & os, long double ld ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		PrintWithDP( os, "%.*Lg", ld, LDBL_DIG );
 		return os;
@@ -202,5 +202,5 @@
 
 	ostype & ?|?( ostype & os, float _Complex fc ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 //		os | crealf( fc ) | nonl;
 		PrintWithDP( os, "%g", crealf( fc ) );
@@ -214,5 +214,5 @@
 
 	ostype & ?|?( ostype & os, double _Complex dc ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 //		os | creal( dc ) | nonl;
 		PrintWithDP( os, "%.*lg", creal( dc ), DBL_DIG );
@@ -226,5 +226,5 @@
 
 	ostype & ?|?( ostype & os, long double _Complex ldc ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 //		os | creall( ldc ) || nonl;
 		PrintWithDP( os, "%.*Lg", creall( ldc ), LDBL_DIG );
@@ -257,20 +257,20 @@
 		// first character IS NOT spacing or closing punctuation => add left separator
 		unsigned char ch = str[0];						// must make unsigned
-		if ( sepPrt( os ) && mask[ ch ] != Close && mask[ ch ] != OpenClose ) {
-			fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) && mask[ ch ] != Close && mask[ ch ] != OpenClose ) {
+			fmt( os, "%s", $sepGetCur( os ) );
 		} // if
 
 		// if string starts line, must reset to determine open state because separator is off
-		sepReset( os );									// reset separator
+		$sepReset( os );								// reset separator
 
 		// last character IS spacing or opening punctuation => turn off separator for next item
 		size_t len = strlen( str );
 		ch = str[len - 1];								// must make unsigned
-		if ( sepPrt( os ) && mask[ ch ] != Open && mask[ ch ] != OpenClose ) {
+		if ( $sepPrt( os ) && mask[ ch ] != Open && mask[ ch ] != OpenClose ) {
 			sepOn( os );
 		} else {
 			sepOff( os );
 		} // if
-		if ( ch == '\n' ) setNL( os, true );			// check *AFTER* sepPrt call above as it resets NL flag
+		if ( ch == '\n' ) $setNL( os, true );			// check *AFTER* $sepPrt call above as it resets NL flag
 		return write( os, str, len );
 	} // ?|?
@@ -281,5 +281,5 @@
 
 // 	ostype & ?|?( ostype & os, const char16_t * str ) {
-// 		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+// 		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 // 		fmt( os, "%ls", str );
 // 		return os;
@@ -288,5 +288,5 @@
 // #if ! ( __ARM_ARCH_ISA_ARM == 1 && __ARM_32BIT_STATE == 1 ) // char32_t == wchar_t => ambiguous
 // 	ostype & ?|?( ostype & os, const char32_t * str ) {
-// 		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+// 		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 // 		fmt( os, "%ls", str );
 // 		return os;
@@ -295,5 +295,5 @@
 
 // 	ostype & ?|?( ostype & os, const wchar_t * str ) {
-// 		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+// 		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 // 		fmt( os, "%ls", str );
 // 		return os;
@@ -301,5 +301,5 @@
 
 	ostype & ?|?( ostype & os, const void * p ) {
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 		fmt( os, "%p", p );
 		return os;
@@ -316,6 +316,6 @@
 	void ?|?( ostype & os, ostype & (* manip)( ostype & ) ) {
 		(ostype &)(manip( os ));
-		if ( getPrt( os ) ) ends( os );					// something printed ?
-		setPrt( os, false );							// turn off
+		if ( $getPrt( os ) ) ends( os );				// something printed ?
+		$setPrt( os, false );							// turn off
 	} // ?|?
 
@@ -330,6 +330,6 @@
 	ostype & nl( ostype & os ) {
 		(ostype &)(os | '\n');
-		setPrt( os, false );							// turn off
-		setNL( os, true );
+		$setPrt( os, false );							// turn off
+		$setNL( os, true );
 		flush( os );
 		return sepOff( os );							// prepare for next line
@@ -337,5 +337,5 @@
 
 	ostype & nonl( ostype & os ) {
-		setPrt( os, false );							// turn off
+		$setPrt( os, false );							// turn off
 		return os;
 	} // nonl
@@ -376,7 +376,7 @@
 	ostype & ?|?( ostype & os, T arg, Params rest ) {
 		(ostype &)(os | arg);							// print first argument
-		sepSetCur( os, sepGetTuple( os ) );				// switch to tuple separator
+		$sepSetCur( os, sepGetTuple( os ) );			// switch to tuple separator
 		(ostype &)(os | rest);							// print remaining arguments
-		sepSetCur( os, sepGet( os ) );					// switch to regular separator
+		$sepSetCur( os, sepGet( os ) );					// switch to regular separator
 		return os;
 	} // ?|?
@@ -384,7 +384,7 @@
 		// (ostype &)(?|?( os, arg, rest )); ends( os );
 		(ostype &)(os | arg);							// print first argument
-		sepSetCur( os, sepGetTuple( os ) );				// switch to tuple separator
+		$sepSetCur( os, sepGetTuple( os ) );			// switch to tuple separator
 		(ostype &)(os | rest);							// print remaining arguments
-		sepSetCur( os, sepGet( os ) );					// switch to regular separator
+		$sepSetCur( os, sepGet( os ) );					// switch to regular separator
 		ends( os );
 	} // ?|?
@@ -415,5 +415,5 @@
 forall( dtype ostype | ostream( ostype ) ) { \
 	ostype & ?|?( ostype & os, _Ostream_Manip(T) f ) { \
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) ); \
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) ); \
 \
 		if ( f.base == 'b' || f.base == 'B' ) {			/* bespoke binary format */ \
@@ -514,5 +514,5 @@
 forall( dtype ostype | ostream( ostype ) ) { \
 	ostype & ?|?( ostype & os, _Ostream_Manip(T) f ) { \
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) ); \
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) ); \
 		char fmtstr[sizeof(DFMTP)];						/* sizeof includes '\0' */ \
 		if ( ! f.flags.pc ) memcpy( &fmtstr, DFMTNP, sizeof(DFMTNP) ); \
@@ -557,5 +557,5 @@
 		} // if
 
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 
 		#define CFMTNP "% * "
@@ -595,5 +595,5 @@
 		} // if
 
-		if ( sepPrt( os ) ) fmt( os, "%s", sepGetCur( os ) );
+		if ( $sepPrt( os ) ) fmt( os, "%s", $sepGetCur( os ) );
 
 		#define SFMTNP "% * "