Index: doc/papers/concurrency/figures/RunTimeStructure.fig
===================================================================
--- doc/papers/concurrency/figures/RunTimeStructure.fig	(revision 53a49cc5405a98077cc25063bb8be418e78c5931)
+++ doc/papers/concurrency/figures/RunTimeStructure.fig	(revision 016b1eb1c94e278d77bf3e8460c08846534f9c67)
@@ -8,164 +8,164 @@
 -2
 1200 2
-6 3855 2775 4155 2925
-1 3 0 1 0 0 0 0 0 0.000 1 0.0000 3930 2850 30 30 3930 2850 3960 2880
-1 3 0 1 0 0 0 0 0 0.000 1 0.0000 4035 2850 30 30 4035 2850 4065 2880
+6 3255 2475 3555 2625
+1 3 0 1 0 0 0 0 0 0.000 1 0.0000 3330 2550 30 30 3330 2550 3360 2580
+1 3 0 1 0 0 0 0 0 0.000 1 0.0000 3435 2550 30 30 3435 2550 3465 2580
 -6
-6 4755 3525 5055 3675
-1 3 0 1 0 0 0 0 0 0.000 1 0.0000 4830 3600 30 30 4830 3600 4860 3630
-1 3 0 1 0 0 0 0 0 0.000 1 0.0000 4935 3600 30 30 4935 3600 4965 3630
+6 4155 3225 4455 3375
+1 3 0 1 0 0 0 0 0 0.000 1 0.0000 4230 3300 30 30 4230 3300 4260 3330
+1 3 0 1 0 0 0 0 0 0.000 1 0.0000 4335 3300 30 30 4335 3300 4365 3330
 -6
-6 4650 2775 4950 2925
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4725 2850 15 15 4725 2850 4740 2865
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4800 2850 15 15 4800 2850 4815 2865
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4875 2850 15 15 4875 2850 4890 2865
+6 4050 2475 4350 2625
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4125 2550 15 15 4125 2550 4140 2565
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4200 2550 15 15 4200 2550 4215 2565
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4275 2550 15 15 4275 2550 4290 2565
 -6
-6 3225 2400 3525 2550
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3300 2475 15 15 3300 2475 3315 2490
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3375 2475 15 15 3375 2475 3390 2490
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3450 2475 15 15 3450 2475 3465 2490
+6 2625 2100 2925 2250
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 2700 2175 15 15 2700 2175 2715 2190
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 2775 2175 15 15 2775 2175 2790 2190
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 2850 2175 15 15 2850 2175 2865 2190
 -6
-6 5475 3450 5625 3750
-1 3 0 1 -1 -1 0 0 20 0.000 1 4.7120 5550 3525 15 15 5550 3525 5535 3540
-1 3 0 1 -1 -1 0 0 20 0.000 1 4.7120 5550 3600 15 15 5550 3600 5535 3615
-1 3 0 1 -1 -1 0 0 20 0.000 1 4.7120 5550 3675 15 15 5550 3675 5535 3690
+6 4875 3150 5025 3450
+1 3 0 1 -1 -1 0 0 20 0.000 1 4.7120 4950 3225 15 15 4950 3225 4935 3240
+1 3 0 1 -1 -1 0 0 20 0.000 1 4.7120 4950 3300 15 15 4950 3300 4935 3315
+1 3 0 1 -1 -1 0 0 20 0.000 1 4.7120 4950 3375 15 15 4950 3375 4935 3390
 -6
-6 4275 3525 4575 3675
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4350 3600 15 15 4350 3600 4365 3615
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4425 3600 15 15 4425 3600 4440 3615
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4500 3600 15 15 4500 3600 4515 3615
+6 3675 3225 3975 3375
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3750 3300 15 15 3750 3300 3765 3315
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3825 3300 15 15 3825 3300 3840 3315
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3900 3300 15 15 3900 3300 3915 3315
 -6
-6 3225 4125 4650 4425
-6 4350 4200 4650 4350
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4425 4275 15 15 4425 4275 4440 4290
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4500 4275 15 15 4500 4275 4515 4290
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4575 4275 15 15 4575 4275 4590 4290
+6 2625 3825 4050 4125
+6 3750 3900 4050 4050
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3825 3975 15 15 3825 3975 3840 3990
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3900 3975 15 15 3900 3975 3915 3990
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3975 3975 15 15 3975 3975 3990 3990
 -6
-1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3450 4275 225 150 3450 4275 3675 4425
-1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4050 4275 225 150 4050 4275 4275 4425
+1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 2850 3975 225 150 2850 3975 3075 4125
+1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3450 3975 225 150 3450 3975 3675 4125
 -6
-6 6675 4125 7500 4425
-6 7200 4200 7500 4350
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 7275 4275 15 15 7275 4275 7290 4290
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 7350 4275 15 15 7350 4275 7365 4290
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 7425 4275 15 15 7425 4275 7440 4290
+6 6075 3825 6900 4125
+6 6600 3900 6900 4050
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 6675 3975 15 15 6675 3975 6690 3990
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 6750 3975 15 15 6750 3975 6765 3990
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 6825 3975 15 15 6825 3975 6840 3990
 -6
-1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 6900 4275 225 150 6900 4275 7125 4425
+1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 6300 3975 225 150 6300 3975 6525 4125
 -6
-6 6675 3525 8025 3975
+6 6075 3225 7425 3675
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 6675 3750 6975 3750
+	 6075 3450 6375 3450
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 7125 3750 7350 3750
+	 6525 3450 6750 3450
 2 2 0 1 -1 -1 0 0 -1 0.000 0 0 0 0 0 5
-	 7800 3975 7800 3525 7350 3525 7350 3975 7800 3975
+	 7200 3675 7200 3225 6750 3225 6750 3675 7200 3675
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 7800 3750 8025 3750
+	 7200 3450 7425 3450
 -6
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 5550 2625 150 150 5550 2625 5700 2625
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 5550 3225 150 150 5550 3225 5700 3225
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 5550 3975 150 150 5550 3975 5700 3975
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3525 2850 150 150 3525 2850 3675 2850
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4200 2475 150 150 4200 2475 4350 2475
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4425 2850 150 150 4425 2850 4575 2850
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4650 2475 150 150 4650 2475 4800 2475
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3975 3600 150 150 3975 3600 4125 3600
-1 3 0 1 0 0 0 0 0 0.000 1 0.0000 3525 3600 30 30 3525 3600 3555 3630
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3750 2475 150 150 3750 2475 3900 2625
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4875 3600 150 150 4875 3600 5025 3750
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3975 2850 150 150 3975 2850 4125 2850
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 7200 2775 150 150 7200 2775 7350 2775
-1 3 0 1 0 0 0 0 0 0.000 1 0.0000 2250 4830 30 30 2250 4830 2280 4860
-1 3 0 1 0 0 0 0 0 0.000 1 0.0000 7200 2775 30 30 7200 2775 7230 2805
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3525 3600 150 150 3525 3600 3675 3600
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3875 4800 100 100 3875 4800 3975 4800
-1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4650 4800 150 75 4650 4800 4800 4875
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4950 2325 150 150 4950 2325 5100 2325
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4950 2925 150 150 4950 2925 5100 2925
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4950 3675 150 150 4950 3675 5100 3675
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 2925 2550 150 150 2925 2550 3075 2550
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3600 2175 150 150 3600 2175 3750 2175
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3825 2550 150 150 3825 2550 3975 2550
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4050 2175 150 150 4050 2175 4200 2175
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3375 3300 150 150 3375 3300 3525 3300
+1 3 0 1 0 0 0 0 0 0.000 1 0.0000 2925 3300 30 30 2925 3300 2955 3330
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3150 2175 150 150 3150 2175 3300 2325
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4275 3300 150 150 4275 3300 4425 3450
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3375 2550 150 150 3375 2550 3525 2550
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 6600 2475 150 150 6600 2475 6750 2475
+1 3 0 1 0 0 0 0 0 0.000 1 0.0000 1650 4530 30 30 1650 4530 1680 4560
+1 3 0 1 0 0 0 0 0 0.000 1 0.0000 6600 2475 30 30 6600 2475 6630 2505
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 2925 3300 150 150 2925 3300 3075 3300
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3275 4500 100 100 3275 4500 3375 4500
+1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4050 4500 150 75 4050 4500 4200 4575
 2 2 0 1 -1 -1 0 0 -1 0.000 0 0 0 0 0 5
-	 2400 4200 2400 3750 1950 3750 1950 4200 2400 4200
+	 1800 3900 1800 3450 1350 3450 1350 3900 1800 3900
 2 2 1 1 -1 -1 0 0 -1 4.000 0 0 0 0 0 5
-	 6300 4500 6300 1800 3000 1800 3000 4500 6300 4500
+	 5700 4200 5700 1500 2400 1500 2400 4200 5700 4200
 2 2 0 1 -1 -1 0 0 -1 0.000 0 0 0 0 0 5
-	 5775 2850 5775 2400 5325 2400 5325 2850 5775 2850
+	 5175 2550 5175 2100 4725 2100 4725 2550 5175 2550
 2 2 0 1 -1 -1 0 0 -1 0.000 0 0 0 0 0 5
-	 5775 4200 5775 3750 5325 3750 5325 4200 5775 4200
+	 5175 3900 5175 3450 4725 3450 4725 3900 5175 3900
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 5175 3975 5325 3975
+	 4575 3675 4725 3675
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 5175 3225 5325 3225
+	 4575 2925 4725 2925
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 5175 2625 5325 2625
+	 4575 2325 4725 2325
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 5775 3975 5925 3975
+	 5175 3675 5325 3675
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 5775 3225 5925 3225
+	 5175 2925 5325 2925
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 5775 2625 5925 2625
+	 5175 2325 5325 2325
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 0 0 2
-	 5175 3975 5175 2625
+	 4575 3675 4575 2325
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 5925 3975 5925 2025
+	 5325 3675 5325 1725
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 5925 3750 6225 3750
+	 5325 3450 5625 3450
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 3450 2625 3225 2625
+	 2850 2325 2625 2325
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 3
 	1 1 1.00 45.00 90.00
-	 5925 2025 4200 2025 4200 2250
+	 5325 1725 3600 1725 3600 1950
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 0 0 2
-	 3225 2625 3225 3600
+	 2625 2325 2625 3300
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 3075 3600 3375 3600
+	 2475 3300 2775 3300
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 3675 3600 3825 3600
+	 3075 3300 3225 3300
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 4125 3600 4275 3600
+	 3525 3300 3675 3300
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 4575 3600 4725 3600
+	 3975 3300 4125 3300
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 5025 3600 5175 3600
+	 4425 3300 4575 3300
 2 2 0 1 -1 -1 0 0 -1 0.000 0 0 0 0 0 5
-	 5775 3450 5775 3000 5325 3000 5325 3450 5775 3450
+	 5175 3150 5175 2700 4725 2700 4725 3150 5175 3150
 2 2 1 1 -1 -1 0 0 -1 4.000 0 0 0 0 0 5
-	 8100 4500 8100 1800 6600 1800 6600 4500 8100 4500
+	 7500 4200 7500 1500 6000 1500 6000 4200 7500 4200
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 7050 2775 6825 2775
+	 6450 2475 6225 2475
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 0 0 2
-	 6825 2775 6825 3750
+	 6225 2475 6225 3450
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 4
 	1 1 1.00 45.00 90.00
-	 7875 3750 7875 2325 7200 2325 7200 2550
+	 7275 3450 7275 2025 6600 2025 6600 2250
 2 2 0 1 -1 -1 0 0 -1 0.000 0 0 0 0 0 5
-	 5850 4950 5850 4725 5625 4725 5625 4950 5850 4950
+	 5250 4650 5250 4425 5025 4425 5025 4650 5250 4650
 2 2 1 1 -1 -1 0 0 -1 3.000 0 0 0 0 0 5
-	 6975 4950 6750 4950 6750 4725 6975 4725 6975 4950
-4 1 -1 0 0 0 10 0.0000 2 105 720 5550 4425 Processors\001
-4 1 -1 0 0 0 10 0.0000 2 120 1005 4200 3225 Blocked Tasks\001
-4 1 -1 0 0 0 10 0.0000 2 150 870 4200 3975 Ready Tasks\001
-4 1 -1 0 0 0 10 0.0000 2 135 1095 7350 1725 Other Cluster(s)\001
-4 1 -1 0 0 0 10 0.0000 2 105 840 4650 1725 User Cluster\001
-4 1 -1 0 0 0 10 0.0000 2 150 615 2175 3675 Manager\001
-4 1 -1 0 0 0 10 0.0000 2 105 990 2175 3525 Discrete-event\001
-4 1 -1 0 0 0 10 0.0000 2 135 795 2175 4350 preemption\001
-4 0 -1 0 0 0 10 0.0000 2 150 1290 2325 4875 genrator/coroutine\001
-4 0 -1 0 0 0 10 0.0000 2 120 270 4050 4875 task\001
-4 0 -1 0 0 0 10 0.0000 2 105 450 7050 4875 cluster\001
-4 0 -1 0 0 0 10 0.0000 2 105 660 5925 4875 processor\001
-4 0 -1 0 0 0 10 0.0000 2 105 555 4875 4875 monitor\001
+	 6375 4650 6150 4650 6150 4425 6375 4425 6375 4650
+4 1 -1 0 0 0 10 0.0000 2 105 720 4950 4125 Processors\001
+4 1 -1 0 0 0 10 0.0000 2 120 1005 3600 2925 Blocked Tasks\001
+4 1 -1 0 0 0 10 0.0000 2 150 870 3600 3675 Ready Tasks\001
+4 1 -1 0 0 0 10 0.0000 2 135 1095 6750 1425 Other Cluster(s)\001
+4 1 -1 0 0 0 10 0.0000 2 105 840 4050 1425 User Cluster\001
+4 1 -1 0 0 0 10 0.0000 2 150 615 1575 3375 Manager\001
+4 1 -1 0 0 0 10 0.0000 2 105 990 1575 3225 Discrete-event\001
+4 1 -1 0 0 0 10 0.0000 2 135 795 1575 4050 preemption\001
+4 0 -1 0 0 0 10 0.0000 2 150 1365 1725 4575 generator/coroutine\001
+4 0 -1 0 0 0 10 0.0000 2 120 270 3450 4575 task\001
+4 0 -1 0 0 0 10 0.0000 2 105 450 6450 4575 cluster\001
+4 0 -1 0 0 0 10 0.0000 2 105 660 5325 4575 processor\001
+4 0 -1 0 0 0 10 0.0000 2 105 555 4275 4575 monitor\001